%define prefix /usr
%define name gtkpool
%define version 0.4.1
%define release 1rhl

Summary:   GTKPool is a 2D pool simulation.
Name:      %{name}
Version:   %{version}
Release:   %{release}
Copyright: GPL
Vendor:    Jacques Fortier & Brian Ashe <gtkpool@seul.org>
Url:       http://gtkpool.seul.org/
Icon:     lo32-app-gtkpool.xpm
Packager:  Brian Ashe <gtkpool@seul.org>
Group:     Amusements/Games
Source:    %{name}-%{version}.tar.gz
BuildRoot: /tmp/%{name}-buildroot

%description
GTKPool is a pool simulation.

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q

%build
./configure --prefix=%{prefix}

# Setup for parallel builds
numprocs=`egrep -c ^cpu[0-9]+ /proc/stat || :`
if [ "$numprocs" = "0" ]; then
  numprocs=1
fi

make -j$numprocs

%install
make install-strip DESTDIR=$RPM_BUILD_ROOT

cd $RPM_BUILD_ROOT
find . -type d | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > $RPM_BUILD_DIR/file.list.gtkpool
find . -type f | sed 's,^\.,\%attr(-\,root\,root) ,' >> $RPM_BUILD_DIR/file.list.gtkpool
find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> $RPM_BUILD_DIR/file.list.gtkpool

%clean
rm -rf $RPM_BUILD_ROOT/*
rm -rf $RPM_BUILD_DIR/gtkpool
rm -rf ../file.list.gtkpool


%files -f ../file.list.gtkpool
